# FACET.tcl--- Oxford FACET module control frame
#  

set frame FACET
set frametitle "FACET module Setup & Monitor"
set icontitle "FACET"

set mname "FACET"

set wrname(CLRACC)      clracc
set wrname(CLRCAL)      clrcal

set wrname(SETACC)      setacc
set wrname(SETCAL)      setcal

set wrname(CALLGRP)     callgrp

set wrname(CLEAR)       clear

set wrname(STATUS)	status
set wrname(LENGTH)	status.length
set wrname(AUTO)	status.auto
set wrname(GROUP)	status.group


set rrname(CLRACC)      clracc
set rrname(CLRCAL)      clrcal

set rrname(SETACC)      setacc
set rrname(SETCAL)      setcal

set rrname(CALLGRP)     callgrp

set rrname(CLEAR)       clear

set rrname(STATUS)	status
set rrname(LENGTH)	status.length
set rrname(AUTO)	status.auto
set rrname(GROUP)	status.group



for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac

set maxmodule [inform camaccontrol inquire [set mname]count]
set modulelist {}
for {set i 1} {$i <= $maxmodule} {incr i} {lappend modulelist $i}

set module [first $modulelist]

set reset_cmd "clear"

proc repaint {} {}

proc redisplay-module {} {
   global debug rrname
   if {$debug} then {puts stderr "redisplay-module with arguments"}
   camac-address
   foreach register [list status.length status.auto status.group] {
      update-widget $register [read-reg $register]
   }
}

proc click arg {
   global debug
   global wtdata
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w {

      LENGTH    -
      AUTO      -
      GROUP     {click-write-data $w $v; redisplay-module}

      SETACC    -
      CLRACC    -
      SETCAL    -
      CLRCAL    -
      CALLGRP   -
      CLEAR 	{click-action $w}

      REDISPLAY	{click-redisplay}
      HELP      {click-help}

      default   {puts stdout $arg}
   }
}

proc make-frame {} {
  global env camcrate camstation rddata

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/charissa" \
      :icon-name "[self icon-title]"

   :panel MODULE :layout T  :padx 5 :pady 5
      :layout H; :row-gap 10

      :hskip 150
      :text CAM-CRATE   :label "CAMAC Crate:"   :w 5 :value $camcrate   :deaf T
      :text CAM-STATION :label "CAMAC Station:" :w 5 :value $camstation :deaf T
      :next-row T
      :number LENGTH :label "Dipstick length:" :w 6 :min 0 :max 16384 :valuex 20c
      :hskip 10
      :checkbox AUTO :label "Auto"
      :checkbox GROUP :label "Group"
      :next-row T; :col-gap 10
      :button SETACC  :label "Set Accumulate"
      :button CLRACC  :label "Clear Accumulate"
      :button SETCAL  :label "Set Calibrate"
      :button CLRCAL  :label "Clear Calibrate"
      :next-row T
      :button CLEAR   :label "Clear"
      :button CALLGRP :label "Call for Group Data"
      :hskip 80
      :button REDISPLAY; :button HELP

   :show T

}
