# TAIL.tcl--- Oxford TAIL module control frame
#  

set frame TAIL
set frametitle "TAIL module Setup & Monitor"
set icontitle "TAIL"

set mname "TAIL"

set wrname(STATUS)       status
set wrname(CAL)          calibrate

set rrname(STATUS)      status
set rrname(CAL)          calibrate

for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac

set maxmodule [inform camaccontrol inquire [set mname]count]
set modulelist {}
for {set i 1} {$i <= $maxmodule} {incr i} {lappend modulelist $i}

set module [first $modulelist]

set reset_cmd "calibrate"

proc repaint {} {}

proc redisplay-module {} {
   global debug
   if {$debug} then {puts stderr "redisplay-module with arguments"}
   camac-address
   update-widget status [read-reg status]
}

proc click arg {
   global debug
   global wtdata
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w {

      STATUS     {click-write-data $w $v; redisplay-module}
      CAL        {click-action $w}
      REDISPLAY  {redisplay-module}

      HELP      {click-help}
      default   {puts stdout $arg}
   }
}

proc make-frame {} {
  global env camcrate camstation rddata

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/charissa" \
      :icon-name "[self icon-title]"

   :panel MODULE :layout T  :padx 5 :pady 5
      :layout H; :row-gap 10

      :hskip 150
      :text CAM-CRATE   :label "CAMAC Crate:"   :w 5 :value $camcrate   :deaf T
      :text CAM-STATION :label "CAMAC Station:" :w 5 :value $camstation :deaf T

      :next-row T; :col-gap 20
      :text STATUS     :label "Status"  :w 8
      :button CAL      :label "set calibrate cycle"
      :button REDISPLAY

   :show T

}
