


#    Note - It seems that DLTs do not always follow the documentation
#    The DLT 4000 at ANU do not have the tape remaining in the documented place
proc get_tape_left {} {
    global DLTsense DriveInfo

    set dtype [string range [lindex $DriveInfo 0] 0 2]
    if {[string toupper $dtype] != "DLT"} then {return 0}

    return  [expr 0x[lindex $DLTsense 23][lindex $DLTsense 24][lindex $DLTsense 25]*4]
}

proc get_tape_length {} {
    global DLTmode DriveInfo

    set dtype [string range [lindex $DriveInfo 0] 0 2]
    if {[string toupper $dtype] != "DLT"} then {return 0}

    set i [lindex $DLTmode 4]
    if {$i <= 80} then {return [expr 15*1024*1024]} else {return [expr 20*1024*1024]}
}

proc update-all-status {} {
    global maxdrives aliaslist usedlist
    global devstates allocated
    global InUse Device
    global TSstatus1 TSstatus2

    set TSstatus1 0
    set TSstatus2 0
    set percent 0
    set blklen 16

    if {[winfo ismapped .]} then {:modify PERCENT :value 0}
    for {set i 1} {$i <= $maxdrives} {incr i} {
        if {$InUse($i) == 0} then {
            if {[winfo ismapped .]} then {:modify STATUS$i :label "Not In Use"}
        } else {
            set alias [lindex $aliaslist [lsearch $usedlist $Device($i)]]
            set fstatus [query-file-status $alias]
            set state [lindex $fstatus 1]
            if {[winfo ismapped .]} then {:modify STATUS$i :label [lindex $devstates $state]}
            if {$state > $allocated} then {
                set st [query-device-status $alias]
                set length [get_tape_length]
                set used [expr [get_tape_length]-[get_tape_left]]
                if {$length > 0} then {
                    set percent [expr ($used*100.0)/$length]
                    set blklen [expr [lindex $fstatus 10] / 1024]
                } else {
                    set percent 0
                }
                if {[winfo ismapped .]} then {:modify PERCENT :value [string range $percent 0 3]}
            }
        }
    }
    set TSstatus2 $percent

    set status [query-stream-state 1]
    if {[winfo ismapped .]} then {
        :modify BLOCKS :value [lindex $status 1]
        :modify KBYTES :value [lindex $status 2]
        :modify RATE   :value [lindex $status 3]
    }
    set TSstatus1 $status
}
